/*
* ROUND END SOUND 2
* Plays sounds (mp3 or wav) at the end of round
* (c) Sir Drink a lot 22.01.2007
*
* - 30 sounds for CT win and T win (if u want to increase, change MAX_SOUNDS and recompile)
* - sounds read from round_sound.cfg. Songs for CT Win marked with ct: and Terror Wins with t:
* - sounds played for "g_soundlength" seconds. (if u want increase, change g_soundlength and recompile)
*
* Needed:
* - LogD and log files (log on command must be executed)
* - file_access_read 1 in adminmod.cfg
* - if u use mp3, u need allow_client_exec 1 in adminmod.cfg
*
* Install:
* - copy amx file to addons/adminmod/scripts/
* - edit plugin.ini and add addons/adminmod/scripts/plugin_logd_round_sound.amx to it.
* - copy file round_sound.cfg to addons/adminmod/config/
* - copy sound files to your cstrike (and to server, if u will enable sound download from server)
* - edit round_sound.cfg, if u want to change something (be sure, last line must be empty!!!);
* - make *.res files that clients can download sounds from the server, if u want to.
*
* Make a mapchange
* - execute admin_rs on to enable the plugin
* - execute admin_rs_playtime x seconds to set play length of sounds.
*
* ENJOY THE SILENCE! ;)
*
* Commands:
* - admin_rs [on/off]: enables/disables plugin
* - admin_rs_playtime [x]: duration in seconds, songs get played after round end
* - admin_rs_playlist: displays soundlist of round_sound.cfg
*
*
*/

#include <string>
#include <admin>
#include <adminlib>

#define ACCESS_CONSOLE	131072
new STRING_VERSION[MAX_DATA_LENGTH]="0.82";

#define MAX_SOUNDS_T 30
#define MAX_SOUNDS_CT 30
new Key[]="am_sound";

new g_soundfile[]="addons/adminmod/config/round_sound.cfg";
new g_sounds_ct[MAX_SOUNDS_CT][MAX_TEXT_LENGTH];
new g_sounds_t[MAX_SOUNDS_T][MAX_TEXT_LENGTH];
new g_loaded_ct;
new g_loaded_t;

//PLUGIN SETTINGS
new g_plugin=1;
new g_soundlength=15;

public plugin_init() {
	if(getvar("file_access_read")){
		plugin_registerinfo("Round Sound","Plays a song after Round End",STRING_VERSION);
		plugin_registercmd("admin_rs","admin_rs",ACCESS_CONFIG,"admin_rs [on/off]: enables/disables plugin");
		plugin_registercmd("admin_rs_playtime","admin_rs_playtime",ACCESS_CONFIG,"admin_rs_playtime [x]: duration in seconds, songs get played after round end");
		plugin_registercmd("admin_rs_playlist","admin_rs_playlist",ACCESS_CONFIG,"admin_rs_playlist: displays soundlist of round_sound.cfg");
		plugin_registercmd("playwin_sound","playwin_sound",ACCESS_CONSOLE);
		exec( "logd_reg 61 admin_command playwin_sound");	/*TEAMACTION-EVENT*/	
		read_sounds(0);
		get_vaultnumdata("ROUND_SOUND_PLUGIN",g_plugin);
		get_vaultnumdata("ROUND_SOUND_LENGTH",g_soundlength);
	}else{
		plugin_registerinfo("Round Sound","DISABLED! file_access_read 1 missing in adminmod.cfg",STRING_VERSION);
		selfmessage("[ROUND-SOUND] Plugin disabled! No file_access_read 1 set in adminmod.cfg");
		g_plugin=0;
	}
	return PLUGIN_CONTINUE;
}

public admin_rs(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	if(strlen(Data)>0){
		g_plugin = check_param(Data);
		set_vaultnumdata("ROUND_SOUND_PLUGIN",g_plugin);
	}
	snprintf(Data,MAX_DATA_LENGTH,"[ROUND SOUND] Plugin is set to %i (1=ON/0=OFF)",g_plugin);
	selfmessage(Data);
	return PLUGIN_HANDLED;
}

public admin_rs_playtime(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	if(strlen(Data)>0){
		g_soundlength = strtonum(Data);
		set_vaultnumdata("ROUND_SOUND_LENGTH",g_soundlength);
	}
	snprintf(Data,MAX_DATA_LENGTH,"[ROUND SOUND] Sound play time is set to %i seconds",g_soundlength);
	selfmessage(Data);
	return PLUGIN_HANDLED;
}

public admin_rs_playlist(HLCommand,HLData,HLUserName,UserIndex) {
	read_sounds(1);
	return PLUGIN_HANDLED;
}
	
//INITIALIZE READ AFTER MAPCHANGE
read_sounds(set){
	new Text[MAX_TEXT_LENGTH];
	new Mark[4];
	new Sound[MAX_TEXT_LENGTH];
	new iFileSize;
	new i;
	
	if(set){
		selfmessage("[ROUND SOUND PLAYLIST]");
		selfmessage("[CT SOUNDS:]");
		for(i=1;i<=g_loaded_ct;i++){
			snprintf(Text,MAX_TEXT_LENGTH,"%i. %s",i,g_sounds_ct[i]);
			selfmessage(Text);
		}
		selfmessage("[T SOUNDS:]");
		for(i=1;i<=g_loaded_t;i++){
			snprintf(Text,MAX_TEXT_LENGTH,"%i. %s",i,g_sounds_t[i]);
			selfmessage(Text);
		}
		snprintf(Text,MAX_TEXT_LENGTH,"[ROUND-SOUND] %i CT sounds and %i T sounds loaded!",g_loaded_ct,g_loaded_t);
		selfmessage(Text);
	}else{
		if(fileexists(g_soundfile)){
			iFileSize=filesize(g_soundfile);
			if(iFileSize>=MAX_SOUNDS_T+MAX_SOUNDS_CT){
				iFileSize=MAX_SOUNDS_T+MAX_SOUNDS_CT-1;
			}
			for(i=1;i<=iFileSize;i++){
				readfile(g_soundfile,Sound,i,MAX_TEXT_LENGTH);
				strsep(Sound,":",Mark,4,Sound,MAX_TEXT_LENGTH);
				if(Mark[0]=='c'){
					g_loaded_ct++;
					strcpy(g_sounds_ct[g_loaded_ct],Sound,MAX_TEXT_LENGTH);
				}else{
					g_loaded_t++;
					strcpy(g_sounds_t[g_loaded_t],Sound,MAX_TEXT_LENGTH);
				}
				strinit(Sound);
			}
			snprintf(Text,MAX_TEXT_LENGTH,"[ROUND-SOUND] %i CT sounds and %i T sounds loaded!",g_loaded_ct,g_loaded_t);
			selfmessage(Text);
		}else{
			snprintf(Text,MAX_TEXT_LENGTH,"[ROUND-SOUND] Can't find ^"%s^"",g_soundfile);
			selfmessage(Text);
			g_plugin=0;
		}
	}
}


//MAIN FUNCTIONS
public playwin_sound(HLCommand,HLData,HLUserName,UserIndex) {
	if(g_plugin){
		new Data[MAX_DATA_LENGTH];
		new Team[MAX_NAME_LENGTH];
		new rand;
		convert_string(HLData,Data,MAX_DATA_LENGTH);
		strsep(Data," ",Team,MAX_NAME_LENGTH,Data,MAX_TEXT_LENGTH);
		if(Team[0]=='T'){
			rand=random(g_loaded_t)+1;
			if(strlen(g_sounds_t[rand])==0){
				rand=1;
			}
			strcpy(Data,g_sounds_t[rand],MAX_DATA_LENGTH);
		}else{
			rand=random(g_loaded_ct)+1;
			if(strlen(g_sounds_ct[rand])==0){
				rand=1;
			}
			strcpy(Data,g_sounds_ct[rand],MAX_DATA_LENGTH);
		}
		playsound_all(Data);
		set_timer("stopsound_all",g_soundlength,1);
	}
	return PLUGIN_CONTINUE;
}

allowsound(User[]){
	new Info[MAX_NUMBER_LENGTH];
	new iInfo;
	new Authid[MAX_AUTHID_LENGTH];
	get_userAuthID(User,Authid,MAX_AUTHID_LENGTH);
	if(strcmp(Authid,"BOT")!=0){
		get_userinfo(User,Key,Info,MAX_NUMBER_LENGTH);
		iInfo=strtonum(Info);
		if(strlen(Info)==0 || iInfo > 0){/*damit wird automatisch immer der Sound auf 1 gesetzt,wenn kein setinfo vorhanden, bis 'stop' eingegeben wird*/
			return 1;
		}
	}
	return 0;
}

playsound_all(WinSound[]){
	new Text[MAX_TEXT_LENGTH];
	new Player[MAX_NAME_LENGTH];
	new i;
	new maxplayers=maxplayercount();
		
	for(i=1;i<=maxplayers;i++){
		if(playerinfo(i,Player,MAX_NAME_LENGTH)){
			if(allowsound(Player)){
				if(strstrx(WinSound,"mp3")!=-1){
					snprintf(Text,MAX_TEXT_LENGTH,"mp3 play %s",WinSound);
					execclient(Player,Text);
				}else{
					speakto(Player,WinSound);
				}
			}
		}
	}
}

public stopsound_all(Timer,Repeat,HLUser,HLParam) {
	new Player[MAX_NAME_LENGTH];
	new maxplayers=maxplayercount();
	new i;
	for(i=1;i<=maxplayers;i++){
		if(playerinfo(i,Player,MAX_NAME_LENGTH)){
			execclient(Player,"mp3 stop");
			speakto(Player,"");
		}
	}
}
	
	
	
	
	
	
	
	
	
